/* Program kredit
   Berechnet Zins, Tilgung und Restdarlehen bei Abzahlungen */
/* ======================================================================== */

/*		Die Standard-Bibliothek
#include <assert.h>		Fehlersuche
#include <ctype.h>		Tests fuer Zeichenklassen
#include <errno.h>
#include <float.h>		Grenzwerte einer Implementierung
#include <limits.h>		Grenzwerte einer Implementierung
#include <locale.h>
#include <math.h>		Mathematische Funktionen
#include <setjmp.h>		Globale Spruenge
#include <signal.h>		Signale
#include <stdarg.h>		Variable Argumentlisten
#include <stddef.h>             in /usr/include/linux/
#include <stdio.h>		Ein- und Ausgabe
#include <stdlib.h>		Hilfsfunktionen
#include <string.h>		Funktionen fuer Zeichenketten
#include <time.h>		Funktionen fuer Datum und Uhrzeit
*/

#include <stdio.h>		/* Ein- und Ausgabe */
#include <stdlib.h>		/* Hilfsfunktionen */

#define DEBUGno
#define DEBUG1no
#define DEBUG2no

/* ======================================================================== */
main(int argc, char *argv[])
{
  int jahr        = 0;
  int mon         = 0;
  int laufzeit    = 0;
  int nurdarl     = 0;
  int quit        = 0;
  double kapital  = 0;
  double zinssatz = 0;
  double tilgsatz = 0;
  double rate     = 0;
  double zins     = 0;
  double tilgung  = 0;
  double zinssum  = 0;
  double tilgsum  = 0;
  double restsum  = 0;
  char *prog      = argv[0];           /* programmname fuer fehlermeldungen */
  
#ifdef DEBUG
  printf("main:\n");
#endif

  if ((argc > 1) && strcmp(argv[1], "-h") == 0)      /* parameter = -h */
  {
    printf("kredit -h | Darlehen Zinssatz Rate [Mon]\n");
    printf("-h           = Diese Hilfe\n");
    printf("Darlehen     = Darlehensbetrag (wenn negativ dann output nur Restdarlehen).\n");
    printf("Zinssatz     = Zinssatz in Prozent\n");
    printf("Rate         = Monatlicher Ratenbetrag.\n");
    printf("Mon          = Anzahl der Berechnungsmonate (default = alle)\n");
    printf("\n");
    printf("Berechnet Zins, Tilgung, Zinssumme, Tilgungssumme und Restdarlehen\n");
    exit(0);
  }

  if (argc < 4)                                  /* weniger als 3 parameter */
  {
    printf("Error - missing parameters!\n");
    exit(1);
  }

  if (argc >= 4)                                 /* mind. 3 parameter */
  {
    kapital = atof(argv[1]);
    if (kapital < 0.0)
    {
      kapital = -1.0 * kapital;
      nurdarl = 1;
    }
    zinssatz = atof(argv[2]);
    rate     = atof(argv[3]);
  }
  
  if (argc == 5)                                 /* 4 parameter */
    laufzeit = atoi(argv[4]);

  if (argc > 5)                                  /* mehr als 4 parameter */
  {
    printf("Error - too many parameters!\n");
    exit(1);
  }

/*
  zins     = kapital / 100 * zinssatz / 12;    Monatszins
  tilgung  = (rate - zins);                    Monatstilgung
  tilgsatz = 100 / kapital * tilgung * 12;     Jahreszinssatz
*/
  tilgsatz = 100 / kapital * (rate - (kapital / 100 * zinssatz / 12)) * 12;
  restsum  = kapital;
  zins     = restsum / 100 * zinssatz / 12;

  if (zins < rate)
  {
    if (nurdarl == 0)
    {
/*      printf("DARLEHEN:%10.2f | ZINSSATZ: %5.2f% | TILGSATZ-BEG: %6.2f% | RATE:%9.2f\n\n",
             kapital, zinssatz, tilgsatz, rate); */
      printf("DARLEHEN:%10.2f | ZINSSATZ: %5.2f% | RATE:%9.2f\n\n",
             kapital, zinssatz, rate);
      printf("JAHR  MON         ZINS      TILGUNG    ZINSSUMME    TILGSUMME RESTDARLEHEN\n");
    }
    while (quit == 0)
    {
      mon     = mon + 1;
      zins    = restsum / 100 * zinssatz / 12;
      tilgung = rate - zins;
      zinssum = zinssum + zins;
      tilgsum = tilgsum + tilgung;
      restsum = restsum - tilgung;

      if ((restsum > 0.0) && ((laufzeit == 0) || (mon <= laufzeit)))
      {
        if ((mon % 12) == 0)
        {
          jahr = jahr + 1;
          if (nurdarl == 0)
            printf("%4i ", jahr);
        }
        else
          if (nurdarl == 0)
            printf("     ");
        if (nurdarl == 0)
          printf("%4i %12.2f %12.2f %12.2f %12.2f %12.2f\n",
                 mon, zins, tilgung, zinssum, tilgsum, restsum);
      }
      else
        quit = 1;
    }
    if (nurdarl == 1)
    {
      restsum = restsum + tilgung;
      printf("%0.2f\n", restsum);
    }
  }
  else
    printf("Error - Monatliche Zinsen sind hoeher als die Rate!\n");
  exit(1);
}
